program QCScraper;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils,
  Winapi.ActiveX,
  ICDSReportPublicInterface1 in 'ICDSReportPublicInterface1.pas',
  uQCScraper in 'uQCScraper.pas';

procedure DoProgress(Value: Integer);
var
  S: string;
begin
  S := Value.ToString;
  Write(S, StringOfChar(#8, Length(S)));
end;

procedure ShowDataType(const Value: string);
begin
  Writeln;
  Write(Value + ':');
end;

procedure ScrapeQC(AUsername, APassword, AFilename: string);
var
  scrp: TQCScraper;
begin
  scrp := TQCScraper.Create(AUsername, APassword, AFilename);
  try
    scrp.OnDataType := ShowDataType;
    scrp.OnProgress := DoProgress;
    scrp.Execute;
  finally
    scrp.Free;
  end;
end;

var
  Username: string = ''; // your email of your EDN account
  Password: string = ''; // your password of your EDN account
  Filename: string = ''; // name of the file to write

procedure Main;
begin
  CoInitialize(nil);
  try
    ScrapeQC(Username, Password, Filename);
  finally
    CoUninitialize;
  end;
  Writeln;
end;

begin
  try
    Main;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
